unit Titlebar;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type TBtn = record
  L, T, W, H: Integer;
  Visible: Boolean;
  end;
type TPAlign = (alTop, alLeft, alBottom, alRight);
type TAutoHideType = (ahtSide, ahtAnyWhere, ahtMinimize, ahtOtherMin);
type TSuttlety = Single;

type
  TTitlebar = class(TImage)
  private
    A: Byte;
    MO: Integer;
    MD: Byte;
    CloseBtn, MinBtn, MaxBtn, LeIcon: TBtn;
    BMCB, BMMB, BMSB, BMRB: TBitmap;
    ourIcon: TIcon;
    IsMax, blnConcaved, blnRaised, blnResizable, blnAutoRedraw: Boolean;
    blnAutoHide, blnUseIcon, IsActive: Boolean;
    blnTBConcaved, blnTBRaised: Boolean;
    currentlychecking: boolean;
    pmIcon: TPopupMenu;
    pmClose, pmMin, pmMax, pmRestore: TMenuItem;
    alAlign: TPAlign;
    colr, decolr, frmcolr, btncolr: TColor;
    intBorderWidth: Integer;
    intAutoHideWidth: Integer;
    intWidth, intHeight, intLeft, intTop, intTBarWidth: Integer;
    intTBarBorderWidth: Integer;
    strCaption: ShortString;
    ahtHidetype: TAutoHideType;
    LastPos: TPoint;
    blnShowInTaskBar: Boolean;
    FOnResize: TNotifyEvent;
    intAHD: Integer;
    blnTransparent: Boolean;
    intRgn: LongInt;
    sSuttle: TSuttlety;
    ourBMP: TBitmap;
    blnUsePic: Boolean;
    clrMaskColor: TColor;
    blnAlreadyMasking: Boolean;

    procedure pmCloseOnClick(Sender: TObject);
    procedure pmMaxOnClick(Sender: TObject);
    procedure pmMinOnClick(Sender: TObject);
    procedure pmRestoreOnClick(Sender: TObject);
    procedure SetResizable(NewValue: Boolean);
    procedure SetRaised(NewValue: Boolean);
    procedure SetConcaved(NewValue: Boolean);
    procedure SetTBRaised(NewValue: Boolean);
    procedure SetTBConcaved(NewValue: Boolean);
    procedure SetTBarWidth(NewValue: Integer);
    procedure SetCloseBtn(NewValue: Boolean);
    procedure SetMinBtn(NewValue: Boolean);
    procedure SetMaxBtn(NewValue: Boolean);
    procedure SetBorderWidth(NewValue: Integer);
    procedure SetUseIcon(NewValue: Boolean);
    procedure SetIcon(NewIcon: TIcon);
    procedure SetColor(NewColor: TColor);
    procedure SetDeColor(NewColor: TColor);
    procedure SetCaption(NewCaption: ShortString);
    procedure SetAlign(NewAlign: TPAlign);
    procedure SetFrmColr(NewValue: TColor);
    procedure SetBtnColr(NewValue: TColor);
    procedure SetAutoRedraw(NewValue: Boolean);
    procedure SetAutoHide(NewValue: Boolean);
    procedure SetAutoHideWidth(NewValue: Integer);
    procedure SetWidth(NewValue: Integer);
    procedure SetHeight(NewValue: Integer);
    procedure SetTBarBorderWidth(NewValue: Integer);
    procedure SetIsMax(NewValue: Boolean);
    procedure SetShowInTaskBar(NewValue: Boolean);
    procedure SetAHD(NewValue: Integer);
    procedure SetSuttle(NewValue: Single);
    procedure SetUsePic(NewValue: Boolean);
    procedure SetBMP(NewValue: TBitmap);

    procedure DeActivate(Sender: TObject);
    procedure Activate(Sender: TObject);
    procedure FreePopup;
    procedure RaisePopupMenu;
    procedure DrawSidewaysCanvas(X: Integer; Y: Integer);
    function GetTextColor(col: TColor): TColor;
    procedure CheckMouseOver;

    procedure DrawForm;
    procedure DrawTitleBar;
    procedure MakeBitmaps;
    procedure CalcAlign;

    { Private declarations }
  protected
    procedure MouseMove(Sender: TObject; Shift: TShiftState; X,
              Y: Integer);
    procedure MouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer); virtual;
    procedure MouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer); virtual;
    procedure DblClick(Sender: TObject); virtual;
    { Protected declarations }
  public
    ClientR: TRect;
    procedure SetTransparent(NewValue: Boolean);
    procedure MakeTitleBar;
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;
    { Public declarations }
  published
    { Published declarations }
      property AutoHideDelay: Integer read intAHD write SetAHD default 2;
      property FormColor: TColor read frmcolr write SetFrmColr;
      property CloseButton: Boolean read CloseBtn.Visible write SetCloseBtn;
      property MinButton: Boolean read MinBtn.Visible write SetMinBtn;
      property MaxButton: Boolean read MaxBtn.Visible write SetMaxBtn;
      property BorderWidth: Integer read intBorderWidth write SetBorderWidth;
      property UseIcon: Boolean read blnUseIcon write SetUseIcon;
      property Icon: TIcon read ourIcon write SetIcon;
      property Color: TColor read colr write SetColor default clBlue;
      property DeActiveColor: TColor read decolr write SetDeColor default clBlue;
      property Caption: ShortString read strCaption write SetCaption;
      property Align: TPAlign read alAlign write SetAlign default alTop;
      property Concaved: Boolean read blnConcaved write SetConcaved;
      property Raised: Boolean read blnRaised write SetRaised;
      property TBConcaved: Boolean read blnTBConcaved write SetTBConcaved;
      property TBRaised: Boolean read blnTBRaised write SetTBRaised;
      property Width: Integer read intWidth write SetWidth;
      property Height: Integer read intHeight write Setheight;
      property TBarWidth: Integer read intTBarWidth write SetTBarWidth;
      property ButtonColor: TColor read btncolr write SetBtnColr;
      property Resizable: Boolean read blnResizable write SetResizable;
      property AutoRedraw: Boolean read blnAutoRedraw write SetAutoRedraw;
      property AutoHide: Boolean read blnAutoHide write SetAutoHide;
      property AutoHideWidth: Integer read intAutoHideWidth write SetAutoHideWidth;
      property TBarBorderWidth: Integer read intTBarBorderWidth write SetTBarBorderWidth;
      property Maximized: Boolean read IsMax write SetIsMax;
      property AutoHideType: TAutoHideType read ahtHideType write ahtHideType;
      property ShowInTaskBar: Boolean read blnShowInTaskBar write SetShowInTaskBar;
      property OnResize: TNotifyEvent read FOnResize write FOnResize;
      property Transparent: Boolean read blnTransparent write SetTransparent;
      property Suttle: TSuttlety read sSuttle write SetSuttle;
      property UsePic: Boolean read blnUsePic write SetUsePic;
      property FormBMP: TBitmap read ourBMP write SetBMP;
      property MaskColor: TColor read clrMaskColor write clrMaskColor;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Seths', [TTitlebar]);
end;

procedure TTitlebar.SetBMP(NewValue: TBitmap);
begin

   ourBMP.Assign( NewValue );
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetTransparent(NewValue: Boolean);
var
  I: Integer;
  A: TControl;
  MTempRgn, TempRgn: Integer;

  B, H, Lef, Tof: Integer;

begin

   if blnAlreadyMasking then exit; //So we dont over do it. Very bad line of code to remove
   blnAlreadyMasking := True;
   if NewValue then begin
      if blnTransparent then begin //Reset the transparent
         SetWindowRgn( Parent.Handle, 0, True );
         DeleteObject(intRgn);
      end;
      blnTransparent := True;

      if Align = alTop then //Make Client area region
         TempRgn := CreateRectRgn( intLeft, intTop + intHeight, intLeft + intWidth, Parent.Height - intBorderWidth )
      else if Align = alLeft then
         TempRgn := CreateRectRgn( intLeft + intWidth, intTop, Parent.Width - intBorderWidth, intTop + intHeight )
      else if Align = alBottom then
         TempRgn := CreateRectRgn( intLeft, intBorderWidth, intLeft + intWidth, Parent.Height - intHeight - intBorderWidth )
      else if Align = alRight then
         TempRgn := CreateRectRgn( intBorderWidth, intTop, Parent.Width - intWidth - intBorderWidth, intTop + intHeight );
      intRgn := CreateRectRgn(0,0,Parent.Width,Parent.Height); //Create main region
      CombineRgn( intRgn, intRgn, TempRgn, RGN_DIFF ); //Add transparent client area
      DeleteObject( TempRgn );

      for I := 0 to TForm(Parent).ComponentCount - 1 do begin //Create a region for all components
         if (TForm(Parent).Components[I] is TControl) then begin
            A := TControl(TForm(Parent).Components[I]);
            if ((A.Visible) and (A.Name <> Name) and (A.Parent = Parent)) then begin
               TempRgn := CreateRectRgn( A.Left, A.Top, A.Left + A.Width, A.Top + A.Height );
               CombineRgn( intRgn, intRgn, TempRgn, RGN_OR );
               DeleteObject( TempRgn );
            end;
         end;
      end;

      if blnUsePic then begin //If the form has a picture then make it transparent
         MTempRgn := CreateRectRgn( ClientR.Left, ClientR.Top, ClientR.Right, ClientR.Bottom );
         CombineRgn( MTempRgn, MTempRgn, MTempRgn, RGN_DIFF );
         for Tof := ClientR.Top to ClientR.Bottom - 1 do begin
            for Lef := ClientR.Left to ClientR.Right do begin
               Application.ProcessMessages;
               if (Canvas.Pixels[Lef, Tof] = clrMaskColor) or (Lef = ClientR.Right) then begin
                  if B > 0 then begin
                     TempRgn := CreateRectRgn( Lef - B, Tof, Lef, Tof + 1);
                     CombineRgn( MTempRgn, MTempRgn, TempRgn, RGN_OR );
                     DeleteObject( TempRgn );
                  end;
                  B := 0;
               end else begin
               B := B + 1;
               end;
            end;
            B := 0;
         end;
         CombineRgn( intRgn, intRgn, MTempRgn, RGN_OR );
         DeleteObject( MTempRgn );
      end;
      SetWindowRgn( TForm(Parent).Handle, intRgn, True );
   end else begin
      SetWindowRgn( TForm(Parent).Handle, 0, True );
      DeleteObject( intRgn );
      intRgn := 0;
      blnTransparent := False;
   end;
   blnAlreadyMasking := False;

end;

procedure TTitlebar.CheckMouseOver;
var
  Po: TPoint;
  T: double;
  I, PT: Integer;
begin

   if ((not blnAutoHide) or (CurrentlyChecking)) then exit;
   CurrentlyChecking := True;
   MO := intAHD;
   T := Time;
   I := Trunc((T - Trunc(T)) * 100000);
   PT := I;
   repeat

      GetCursorPos(Po);
      if ((Po.X > Parent.Left) and (Po.X < Parent.Left + Parent.Width) and
          (Po.Y > Parent.Top) and (Po.Y < Parent.Top + Parent.Height)) then MO := intAHD;

      T := Time;
      I := Trunc((T - Trunc(T)) * 100000);
      if ((MO > 0) and (I <> PT)) then begin
         MO := MO - 1;
         T := Time;
         I := Trunc((T - Trunc(T)) * 100000);
         PT := I;
      end;

      case ahtHideType of
        ahtSide: begin
         if Align = alTop then begin
            if MO = 0 then Parent.Top := Screen.Height - intAutoHideWidth
                      else Parent.Top := Screen.Height - Parent.Height;
         end else if Align = alLeft then begin
            if MO = 0 then Parent.Left := Screen.Width - intAutoHideWidth
                      else Parent.Left := Screen.Width - Parent.Width;
         end else if Align = alRight then begin
            if MO = 0 then Parent.Left := -Parent.Width + intAutoHideWidth
                      else Parent.Left := 0;
         end else if Align = alBottom then begin
            if MO = 0 then Parent.Top := -Parent.Height + intAutoHideWidth
                      else Parent.Top := 0;
         end;
        end;
       ahtAnyWhere: begin
         if Align = alTop then begin
            if MO = 0 then Parent.Top := Screen.Height - intAutoHideWidth
                      else Parent.Top := LastPos.Y;
         end else if Align = alLeft then begin
            if MO = 0 then Parent.Left := Screen.Width - intAutoHideWidth
                      else Parent.Left := LastPos.X;
         end else if Align = alRight then begin
            if MO = 0 then Parent.Left := -Parent.Width + intAutoHideWidth
                      else Parent.Left := LastPos.X;
         end else if Align = alBottom then begin
            if MO = 0 then Parent.Top := -Parent.Height + intAutoHideWidth
                      else Parent.Top := LastPos.Y;
         end;
        end;
       ahtMinimize: if MO = 0 then Application.Minimize;
       ahtOtherMin: if MO = 0 then Showwindow( Parent.Handle, SW_MINIMIZE );
      end;
      if ((not blnAutoHide) or
          (IsActive) or
          (MO = 0) or
          (Application.Terminated))
         then CurrentlyChecking := False;
      Application.ProcessMessages;

   until CurrentlyChecking = False;
   if IsMax then begin Parent.Left := 0; Parent.Top := 0; end;

end;

constructor TTitlebar.Create(Owner: TComponent);
begin

  inherited Create(Owner);
  inherited Align := alClient;
  BMCB := TBitmap.Create; //The buttons
  BMMB := TBitmap.Create;
  BMSB := TBitmap.Create;
  BMRB := TBitmap.Create;
  ourBMP := TBitmap.Create;
  ourIcon := TIcon.Create; // our icon
  if ((Parent <> nil) and (IsMax)) then ShowWindow(Parent.Handle, SW_MAXIMIZE);
  IsActive := True;
  //Switch active color and deactive color events
  Application.OnDeactivate := DeActivate;
  Application.OnActivate := Activate;
  //Titlebar events
  OnMouseDown := MouseDown;
  OnMouseMove := MouseMove;
  OnMouseUp := MouseUp;
  OnDblClick := DblClick;
  if intAHD < 2 then intAHD := 2;

end;

destructor TTitlebar.Destroy;
begin

   BMCB.Free;
   BMMB.Free;
   BMSB.Free;
   BMRB.Free;
   ourBMP.Free;
   ourIcon.Free;
   inherited Destroy;
   if blnTransparent then DeleteObject( intRgn );

end;

procedure TTitleBar.FreePopup;
begin

   LastPos.X := Parent.Left;
   LastPos.Y := Parent.Top;
   pmClose.Free;
   pmMax.Free;
   pmMin.Free;
   pmRestore.Free;
   pmIcon.Free;

end;

procedure TTitleBar.RaisePopupMenu;
var
  Po: TPoint;
begin

  MD := 40;
  pmIcon := TPopupMenu.Create( Self );
  pmClose := TMenuItem.Create( Self );
  pmClose.Caption := 'Close';
  pmClose.OnClick := pmCloseOnClick;
  pmMax := TMenuItem.Create( Self );
  pmMax.Caption := 'Maximize';
  pmMax.OnClick := pmMaxOnClick;
  pmMin := TMenuItem.Create( Self );
  pmMin.Caption := 'Minimize';
  pmMin.OnClick := pmMinOnClick;
  pmRestore := TMenuItem.Create( Self );
  pmRestore.Caption := 'Restore';
  pmRestore.OnClick := pmRestoreOnClick;
  pmIcon.Items.Add( pmRestore );
  pmIcon.Items.Add( pmMin );
  pmIcon.Items.Add( pmMax );
  pmIcon.Items.Add( pmClose );

   GetCursorPos(Po);
   if MinBtn.Visible then pmIcon.Items.Items[1].Enabled := True
                      else pmIcon.Items.Items[1].Enabled := False;
   if MaxBtn.Visible then begin
      pmIcon.Items.Items[2].Enabled := IsMax = False;
      pmIcon.Items.Items[0].Enabled := IsMax = True;
   end else begin
      pmIcon.Items.Items[2].Enabled := False;
      pmIcon.Items.Items[0].Enabled := False;
   end;
   pmIcon.Popup(Po.X, Po.Y);

end;

procedure TTitlebar.pmCloseOnClick(Sender: TObject);
begin

   FreePopup;
   Application.Terminate;

end;

procedure TTitlebar.pmMaxOnClick(Sender: TObject);
begin

   //Maximize
   FreePopup;
   ShowWindow(Parent.Handle, SW_MAXIMIZE);
   IsMax := True;
   if Assigned(FOnResize) then FOnResize(Self);
   MakeTitleBar;

end;

procedure TTitlebar.pmMinOnClick(Sender: TObject);
begin

   FreePopup;
   ShowWindow(Application.Handle, SW_SHOW); // Make sure were on the taskbar
   ShowWindow(Application.Handle, SW_MINIMIZE ); //Minimize
   if Assigned(FOnResize) then FOnResize(Self);

end;

procedure TTitlebar.pmRestoreOnClick(Sender: TObject);
begin

   //Restore the form
   FreePopup;
   ShowWindow(Parent.Handle, SW_RESTORE);
   IsMax := False;
   if Assigned(FOnResize) then FOnResize(Self);
   MakeTitleBar;

end;

procedure TTitlebar.DeActivate(Sender: TObject);
begin

   IsActive := False;
   if Application.Terminated then A := 0;
   if A = 1 then begin
      DrawTitleBar;
      CheckMouseOver;
   end;

end;

procedure TTitlebar.Activate(Sender: TObject);
begin

   IsActive := True;
   if A = 1 then begin
      CheckMouseOver;
      DrawTitleBar;
   end else begin
      A := 1;
      TForm(Parent).BorderStyle := bsNone;
      MakeTitlebar;
   end;

end;

procedure TTitlebar.SetUsePic(NewValue: Boolean);
begin

   blnUsePic := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetAHD(NewValue: Integer);
begin

   if ((NewValue < 2) or (NewValue > 100)) then intAHD := 2 else intAHD := NewValue;

end;

procedure TTitlebar.SetSuttle(NewValue: Single);
begin

   if NewValue < 0.1 then NewValue := 0.1;
   sSuttle := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetIsMax(NewValue: Boolean);
begin if not NewValue = IsMax then begin

   IsMax := NewValue;
   if IsMax = True then ShowWindow( Parent.Handle, SW_MAXIMIZE )
                   else ShowWindow( Parent.Handle, SW_RESTORE );
   if Assigned(FOnResize) then FOnResize(Self);
   MakeTitleBar;

end; end;

procedure TTitlebar.SetShowInTaskBar(NewValue: Boolean);
begin

   blnShowInTaskBar := NewValue;
   if NewValue = False then begin
      Application.ShowMainForm := False;
      ShowWindow( Parent.Handle, SW_RESTORE );
   end else Application.ShowMainForm := True;

end;

procedure TTitlebar.SetTBarBorderWidth(NewValue: Integer);
begin

   intTBarBorderWidth := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetAutoHideWidth(NewValue: Integer);
begin

   intAutoHideWidth := NewValue;

end;

procedure TTitlebar.SetAutoHide(NewValue: Boolean);
begin

   blnAutoHide := NewValue;
   if NewValue = True then CheckMouseOver;

end;

procedure TTitlebar.SetAutoRedraw(NewValue: Boolean);
begin

   blnAutoRedraw := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitleBar.SetTBarWidth(NewValue: Integer);
Begin

   intTBarWidth := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitleBar.SetBtnColr(NewValue: TColor);
begin

   btncolr := NewValue;
   if blnAutoRedraw then MakeBitMaps;

end;

procedure TTitleBar.SetWidth(NewValue: Integer);
begin
//
end;

procedure TTitleBar.SetHeight(NewValue: Integer);
begin
//
end;

procedure TTitlebar.SetResizable(NewValue: Boolean);
begin

   blnResizable := NewValue;

end;

procedure TTitlebar.SetFrmColr(NewValue: TColor);
begin

   frmcolr := NewValue;
   TForm(Parent).Color := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetConcaved(NewValue: Boolean);
begin

   blnConcaved := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetRaised(NewValue: Boolean);
begin

   blnRaised := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetTBConcaved(NewValue: Boolean);
begin

   blnTBConcaved := NewValue;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetTBRaised(NewValue: Boolean);
begin

   blnTBRaised := NewValue;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetAlign(NewAlign: TPAlign);
begin

   alAlign := NewAlign;
   inherited Align := alClient;
   TForm(Parent).borderstyle := bsNone; //Makes sure its pretty
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetCloseBtn( NewValue: Boolean);
begin

   CloseBtn.Visible := NewValue;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetMinBtn( NewValue: Boolean);
begin

   MinBtn.Visible := NewValue;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetMaxBtn( NewValue: Boolean);
begin

   MaxBtn.Visible := NewValue;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetBorderWidth(NewValue: Integer);
begin

   intBorderWidth := NewValue;
   if blnAutoRedraw then MakeTitleBar;

end;

procedure TTitlebar.SetUseIcon(NewValue: Boolean);
begin

   blnUseIcon := NewValue;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetIcon(NewIcon: TIcon);
begin

   ourIcon.Assign( NewIcon );
   TForm(Parent).Icon := ourIcon;
   if blnAutoRedraw then DrawTitleBar;

end;


procedure TTitlebar.SetCaption(NewCaption: ShortString);
begin

   strCaption := NewCaption;
   TForm(Parent).Caption := strCaption;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetColor(NewColor: TColor);
begin

   colr := NewColor;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitlebar.SetDeColor(NewColor: TColor);
begin

   decolr := NewColor;
   if blnAutoRedraw then DrawTitleBar;

end;

procedure TTitleBar.DblClick(Sender: TObject);
var
  Po: TPoint;
begin

GetCursorPos(Po);
if ((Po.X < Parent.Left + intLeft) or (Po.X > Parent.Left + intLeft + intWidth) or
    (Po.Y < Parent.Top + intTop) or (Po.Y > PArent.Top + intTop + intHeight)) then exit;
if MaxBtn.Visible then begin

   if IsMax = False then begin
      ShowWindow(Parent.Handle, SW_MAXIMIZE);
      IsMax := True;
   end else begin
      ShowWindow(Parent.Handle, SW_RESTORE);
      IsMax := False;
   end;
   if Assigned(FOnResize) then FOnResize(Self);
   MakeTitleBar;
   MD := 9; //Skip other button MouseDown events

end;
end;

procedure TTitlebar.MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  A: Byte;
begin if ((Cursor <> crDefault) and (Button = mbLeft)) then begin

   A := 0;
   if Cursor = crSizeWE then begin
      if X < Width div 2 then A := 1 else A := 2;
   end;
   if Cursor = crSizeNS then begin
      if Y < Height div 2 then A := 3 else A := 6;
   end;
   if Cursor = crSizeNWSE then begin
      if X < width div 2 then A := 4 else A := 8;
   end;
   if Cursor = crSizeNESW then begin
      if X < Width div 2 then A := 7 else A := 5;
   end;
   if A > 0 then begin
      ReleaseCapture;
      DefWindowProc( Parent.Handle, WM_SYSCOMMAND, SC_SIZE + A, 0);
      MakeTitleBar;
      LastPos.X := Parent.Left;
      LastPos.Y := Parent.Top;
      if Assigned(FOnResize) then FOnResize(Self);
   end;

end else begin

  if MD <> 9 then begin
   if ((X > CloseBtn.L) and (X < CloseBtn.L + CloseBtn.W) and (Button = mbLeft) and
      (Y > CloseBtn.T) and (Y < CloseBtn.T + CloseBtn.H) and (CloseBtn.Visible = True)) then MD := 1

   else if ((X > MinBtn.L) and (X < MinBtn.L + MinBtn.W) and (Button = mbLeft) and
      (Y > MinBtn.T) and (Y < MinBtn.T + MinBtn.H) and (MinBtn.Visible = True)) then MD := 3

   else if ((X > MaxBtn.L) and (X < MaxBtn.L + MaxBtn.W) and (Button = mbLeft) and
      (Y > MaxBtn.T) and (Y < MaxBtn.T + MaxBtn.H) and (MaxBtn.Visible = True) and (IsMax = False)) then MD := 2

   else if ((X > MaxBtn.L) and (X < MaxBtn.L + MaxBtn.W) and (Button = mbLeft) and
      (Y > MaxBtn.T) and (Y < MaxBtn.T + MaxBtn.H) and (MaxBtn.Visible = True) and (IsMax = True)) then MD := 4

   else if ((X > LeIcon.L) and (X < LeIcon.L + LeIcon.W) and
            (Y > LeIcon.T) and (Y < LeIcon.T + LeIcon.H) and
            (LeIcon.Visible)) then RaisePopupMenu

   else MD := 0;
  end else MD := 0;

	If ((button = mbleft) and (MD = 0) and (IsMax = False) and
      (X > intLeft) and (X < intLeft + intWidth) and
      (Y > intTop) and (Y < intTop + intHeight)) then begin
		releasecapture;
      DefWindowProc( Parent.Handle, WM_syscommand, $F012, 0);
      LastPos.X := Parent.Left;
      LastPos.Y := Parent.Top;
      if Assigned(FOnResize) then FOnResize(Self);
	end else
	If ((button = mbRight) and (MD = 0) and
      (X > intLeft) and (X < intLeft + intWidth) and
      (Y > intTop) and (Y < intTop + intHeight)) then begin
      RaisePopupMenu;
	end;
end;
if MD > 0 then MakeBitmaps;

end;

procedure TTitlebar.MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  D: Integer;
begin

  D := intBorderWidth + 2;
 if ((blnResizable) and (IsMax = False)) then begin
   if (((X < D) and (Y < D)) or
       ((Parent.Width - X < D) and (Parent.Height - Y < D))) then Cursor := crSizeNWSE else
   if ( ((Parent.Width - X < D)   and (Y < D)) or
        ((Parent.Height - Y < D) and (X < D))) then Cursor := crSizeNESW else
   if ((X < D) or (Parent.Width - X < D)) then Cursor := crSizeWE else
   if ((Y < D) or (Parent.Height - Y < D)) then Cursor := crSizeNS else
      Cursor := crDefault;
 end;
 CheckMouseOver;

end;

procedure TTitlebar.MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

   if ((X > CloseBtn.L) and (X < CloseBtn.L + CloseBtn.W) and
       (Y > CloseBtn.T) and (Y < CloseBtn.T + CloseBtn.H) and (MD = 1)) then

   else if ((X > MaxBtn.L) and (X < MaxBtn.L + MaxBtn.W) and
            (Y > MaxBtn.T) and (Y < MaxBtn.T + MaxBtn.H) and (MD = 2)) then

   else if ((X > MaxBtn.L) and (X < MaxBtn.L + MaxBtn.W) and
            (Y > MaxBtn.T) and (Y < MaxBtn.T + MaxBtn.H) and (MD = 4)) then

   else if ((X > MinBtn.L) and (X < MinBtn.L + MinBtn.W) and
            (Y > MinBtn.T) and (Y < MinBtn.T + MinBtn.H) and (MD = 3)) then

   else if MD > 0 then MD := 50;


// Draw the icon and caption
   case MD of
      1: Application.Terminate; // They hit the close button
      2: begin  //Maximize
            ShowWindow(Parent.Handle, SW_MAXIMIZE);
            IsMax := True;
            if Assigned(FOnResize) then FOnResize(Self);
            MakeTitleBar;
         end;
      3: begin
            ShowWindow(Application.Handle, SW_SHOW); // Make sure were on the taskbar
            ShowWindow(Application.Handle, SW_MINIMIZE ); //Minimize
            if Assigned(FOnResize) then FOnResize(Self);
            MakeBitmaps;
         end;
      4: begin            //Restore the form
            ShowWindow(Parent.Handle, SW_RESTORE);
            IsMax := False;
            if Assigned(FOnResize) then FOnResize(Self);
            MakeTitleBar;
         end;
   end;
   LastPos.X := Parent.Left;
   LastPos.Y := Parent.Top;
   if MD = 50 then MakeBitmaps;
   MD := 0;
   Cursor := crDefault;

end;

procedure TTitleBar.MakeTitleBar;
begin

   if sSuttle = 0 then sSuttle := 0.95;
   if A = 0 then exit;
   if Addr(Parent) = nil then exit;
   if not blnShowInTaskBar then
      Showwindow(Application.Handle, SW_HIDE)
   else Showwindow(Application.Handle, SW_SHOW);
   DrawForm;
   if blnTransparent then Transparent := True;

end;

procedure TTitlebar.DrawForm;
var
  Loop, intStart, intFinish, intStep: Integer;
  LR, LG, LB, DR, DG, DB: Integer;
  TLR, TLG, TLB, TDR, TDG, TDB: Integer;
  I: Integer;
begin

  intBorderWidth := intBorderWidth + 1;
  intwidth := intTBarWidth + 4;
  intHeight := intTBarWidth + 4;
  if alAlign = alTop then begin
      intLeft := intBorderWidth;
      intTop := intBorderWidth;
      intWidth := Parent.ClientWidth - (2 * intBorderWidth);
   end else
   if alAlign = alLeft then begin
      intLeft := intBorderWidth;
      intTop := intBorderWidth;
      intHeight := Parent.ClientHeight - (2 * intBorderWidth);
   end else
   if alAlign = alRight then begin
      intLeft := Parent.ClientWidth - intWidth - intBorderWidth;
      intTop := intBorderWidth;
      intHeight := Parent.ClientHeight - (2 * intBorderWidth);
   end else
   if alAlign = alBottom then begin
      intLeft := intBorderWidth;
      intTop := Parent.ClientHeight - intHeight - intBorderWidth;
      intWidth := Parent.ClientWidth - (2 * intBorderWidth);
   end;

   intBorderWidth := intBorderWidth - 1;

// Makes sure the canvas is large enough
   Picture.Bitmap.Width := Parent.Width;
   Picture.Bitmap.Height := Parent.Height;
   inherited Width := Parent.Width;
   inherited Height := Parent.Height;
//Draw the form
   Canvas.Pen.Color := frmcolr; Canvas.Brush.Color := frmcolr;
   Canvas.Rectangle(0,0,Parent.Width,Parent.Height);
//Set the Client Area Rect
   if alAlign = alTop then begin
      ClientR.Left := intBorderWidth;
      ClientR.Top := intBorderWidth + intTBarWidth + 6;
      ClientR.Right := Parent.Width - intBorderWidth;
      ClientR.Bottom := Parent.Height - intBorderWidth;
   end else if alAlign = alLeft then begin
      ClientR.Left := intBorderWidth + intTBarWidth + 6;
      ClientR.Top := intBorderWidth;
      ClientR.Right := Parent.Width - intBorderWidth;
      ClientR.Bottom := Parent.Height - intBorderWidth;
   end else if alAlign = alBottom then begin
      ClientR.Left := intBorderWidth;
      ClientR.Top := intBorderWidth;
      ClientR.Right := Parent.Width - intBorderWidth;
      ClientR.Bottom := Parent.Height - intBorderWidth - intTBarWidth - 6;
   end else begin
      ClientR.Left := intBorderWidth;
      ClientR.Top := intBorderWidth;
      ClientR.Right := Parent.Width - intBorderWidth - intTBarWidth - 6;
      ClientR.Bottom := Parent.Height - intBorderWidth;
   end;
   if blnUsePic then
      Canvas.CopyRect(ClientR, ourBMP.Canvas, ourBMP.Canvas.ClipRect);

if intBorderWidth > 0 then begin
   TLR := (Canvas.Pen.Color and $FF);
   TLG := (Canvas.Pen.Color and $FF00) div $100;
   TLB := (Canvas.Pen.Color and $FF0000) div $10000;
   TDR := TLR;   TDG := TLG;   TDB := TLB;
   LR := Trunc((255 - TLR) / intBorderWidth * sSuttle);
   LG := Trunc((255 - TLG) / intBorderWidth * sSuttle);
   LB := Trunc((255 - TLB) / intBorderWidth * sSuttle);
   DR := Trunc(TLR / intBorderWidth * sSuttle);
   DG := Trunc(TLG / intBorderWidth * sSuttle);
   DB := Trunc(TLB / intBorderWidth * sSuttle);

   if blnConcaved then begin
      intFinish := intBorderWidth;
      intStart := 0;
      intStep := 1;
   end else begin
      intStart := intBorderWidth;
      intFinish := 0;
      intStep := -1;
   end;
   Loop := intStart;
   repeat

     if blnRaised then
        Picture.Bitmap.Canvas.Pen.Color := RGB( TLR, TLG, TLB ) else
        Picture.Bitmap.Canvas.Pen.Color := RGB( TDR, TDG, TDB );

     Picture.Bitmap.Canvas.MoveTo( Parent.Width - Loop, Loop);
     Picture.Bitmap.Canvas.LineTo( Loop, Loop);
     Picture.Bitmap.Canvas.LineTo( Loop, Parent.Height - Loop);

     if blnRaised then
       Picture.Bitmap.Canvas.Pen.Color := RGB( TDR, TDG, TDB ) else
       Picture.Bitmap.Canvas.Pen.Color := RGB( TLR, TLG, TLB );
     Canvas.Font.Color := Picture.Bitmap.Canvas.Pen.Color;

     Picture.Bitmap.Canvas.MoveTo( Loop, Parent.Height - Loop);
     Picture.Bitmap.Canvas.LineTo( Parent.Width - Loop, Parent.Height - Loop);
     Picture.Bitmap.Canvas.LineTo( Parent.Width - Loop, Loop);

     TLR := TLR + LR; TLG := TLG + LG; TLB := TLB + LB;
     TDR := TDR - DR; TDG := TDG - DG; TDB := TDB - DB;
     loop := loop + intStep;
  until Loop = intFinish + intStep;
end;
   DrawTitleBar;
end;

procedure TTitlebar.DrawTitleBar;
var
  Loop, intStart, intFinish, intStep: Integer;
  LR, LG, LB, DR, DG, DB: Integer;
  TLR, TLG, TLB, TDR, TDG, TDB: Integer;
  I: Integer;
begin
// Set the colors
   if IsActive then Canvas.Pen.Color := colr
               else Canvas.Pen.Color := decolr;
   Canvas.Brush.Color := Canvas.Pen.Color;
// Draw the titlebar
   Canvas.Rectangle(intLeft,intTop,intLeft + intWidth,intTop +intHeight);
 if intTBarBorderWidth > 0 then begin
   TLR := (Canvas.Pen.Color and $FF);
   TLG := (Canvas.Pen.Color and $FF00) div $100;
   TLB := (Canvas.Pen.Color and $FF0000) div $10000;
   TDR := TLR;   TDG := TLG;   TDB := TLB;
   LR := Trunc((255 - TLR) div intTBarBorderWidth * sSuttle);
   LG := Trunc((255 - TLG) div intTBarBorderWidth * sSuttle);
   LB := Trunc((255 - TLB) div intTBarBorderWidth * sSuttle);
   DR := Trunc(TLR div intTBarBorderWidth * sSuttle);
   DG := Trunc(TLG div intTBarBorderWidth * sSuttle);
   DB := Trunc(TLB div intTBarBorderWidth * sSuttle);

   if blnTBConcaved then begin
      intFinish := intTBarBorderWidth;
      intStart := 0;
      intStep := 1;
   end else begin
      intStart := intTBarBorderWidth;
      intFinish := 0;
      intStep := -1;
   end;
   Loop := intStart;
   repeat

     if blnTBRaised then
        Picture.Bitmap.Canvas.Pen.Color := RGB( TLR, TLG, TLB ) else
        Picture.Bitmap.Canvas.Pen.Color := RGB( TDR, TDG, TDB );

     Picture.Bitmap.Canvas.MoveTo( intLeft + intWidth - Loop, intTop + Loop);
     Picture.Bitmap.Canvas.LineTo( intLeft + Loop, intTop + Loop);
     Picture.Bitmap.Canvas.LineTo( intLeft + Loop, intTop + intHeight - Loop);

     if blnTBRaised then
       Picture.Bitmap.Canvas.Pen.Color := RGB( TDR, TDG, TDB ) else
       Picture.Bitmap.Canvas.Pen.Color := RGB( TLR, TLG, TLB );
     Canvas.Font.Color := Picture.Bitmap.Canvas.Pen.Color;

     Picture.Bitmap.Canvas.MoveTo( intLeft + Loop, intTop + intHeight - Loop);
     Picture.Bitmap.Canvas.LineTo( intLeft + intWidth - Loop, intTop + intHeight - Loop);
     Picture.Bitmap.Canvas.LineTo( intLeft + intWidth - Loop, intTop + Loop);

     TLR := TLR + LR; TLG := TLG + LG; TLB := TLB + LB;
     TDR := TDR - DR; TDG := TDG - DG; TDB := TDB - DB;
     loop := loop + intStep;
  until Loop = intFinish + intStep;
 end;
   CalcAlign; // Figure out where things will be with current alignment
end;

procedure TTitlebar.CalcAlign;
var
   I: Integer;
   tempC: TColor;
begin

  if Canvas.Font <> nil then begin
     if IsActive then tempC := GetTextColor(colr) else
                      tempC := GetTextColor(decolr);
     Canvas.Font.Color := tempC;
  end;
  // Figure out Width for Icon
  I := intTBarWidth - (2 * intTbarBorderWidth) - 2;

  if Canvas.Font <> nil then begin
     Canvas.Font.Height := I - 2;
  end;
  Canvas.Brush.Style := bsClear;

  if ((alAlign = alTop) or (alAlign = alBottom)) then begin
   // Draw the icon and caption
   if blnUseIcon = True then begin
      LeIcon.Visible := True;
      LeIcon.L := intLeft + 2 + intTBarBorderWidth;
      LeIcon.T := intTop + 2 + intTBarBorderWidth;
      LeIcon.W := I;
      LeIcon.H := I;
      DrawIconEx( Canvas.Handle, LeIcon.L, LeIcon.T, ourIcon.Handle,
         I, I, 0, Canvas.Brush.Handle, DI_IMAGE);
      Canvas.Textout( intLeft + 2 + I + intTBarBorderWidth, intTop + (intHeight div 2) - (Canvas.Textheight(strCaption) div 2), strCaption );
   end else begin
      LeIcon.Visible := False;
      Canvas.Textout( intLeft + 2 + intTbarBorderWidth, intTop + (intHeight div 2) - (Canvas.Textheight(strCaption) div 2), strCaption );
   end;

   // Figure out button rects
   CloseBtn.L := intLeft + intWidth - I - 2 - intTbarBorderWidth;
   CloseBtn.T := intTop + intTBarBorderWidth + 2;
   CloseBtn.W := I;
   CloseBtn.H := I;

   if CloseBtn.Visible then begin
      MaxBtn.L := CloseBtn.L - I - 2;
      MaxBtn.T := CloseBtn.T;
      MaxBtn.W := CloseBtn.W;
      MaxBtn.H := CloseBtn.H;
   end else begin
      MaxBtn.L := CloseBtn.L;
      MaxBtn.T := CloseBtn.T;
      MaxBtn.W := CloseBtn.W;
      MaxBtn.H := CloseBtn.H;
   end;

   if MaxBtn.Visible then begin
      MinBtn.L := MaxBtn.L - I - 2;
      MinBtn.T := MaxBtn.T;
      MinBtn.W := MaxBtn.W;
      MinBtn.H := MaxBtn.H;
   end else begin
      MinBtn.L := MaxBtn.L;
      MinBtn.T := MaxBtn.T;
      MinBtn.W := MaxBtn.W;
      MinBtn.H := MaxBtn.H;
   end;

  end else begin
   // Draw the icon and caption
   if blnUseIcon = True then begin
      LeIcon.Visible := True;
      LeIcon.L := intLeft + 2 + intTBarBorderWidth;
      LeIcon.T := intTop + 2 + intTBarBorderWidth;
      LeIcon.W := I;
      LeIcon.H := I;
      DrawIconEx( Canvas.Handle, LeIcon.L, LeIcon.T, ourIcon.Handle,
         I, I, 0, Canvas.Brush.Handle, DI_IMAGE);
      DrawSidewaysCanvas(0, I + intBorderWidth + intTbarBorderWidth + 2);
   end else begin
      DrawSidewaysCanvas(0, intBorderWidth + 2 + intTbarBorderWidth);
   end;
   // Figure out button rects
   CloseBtn.L := intLeft + intTBarBorderWidth + 2;
   CloseBtn.T := intTop + intHeight - I - 2 - intTbarBorderWidth;
   CloseBtn.W := I;
   CloseBtn.H := I;
   if CloseBtn.Visible then begin
      MaxBtn.L := CloseBtn.L;
      MaxBtn.T := CloseBtn.T - I - 2;
      MaxBtn.W := CloseBtn.W;
      MaxBtn.H := CloseBtn.H;
   end else begin
      MaxBtn.L := CloseBtn.L;
      MaxBtn.T := CloseBtn.T;
      MaxBtn.W := CloseBtn.W;
      MaxBtn.H := CloseBtn.H;
   end;
   if MaxBtn.Visible then begin
      MinBtn.L := MaxBtn.L;
      MinBtn.T := MaxBtn.T - I - 2;
      MinBtn.W := MaxBtn.W;
      MinBtn.H := MaxBtn.H;
   end else begin
      MinBtn.L := MaxBtn.L;
      MinBtn.T := MaxBtn.T;
      MinBtn.W := MaxBtn.W;
      MinBtn.H := MaxBtn.H;
   end;

  end;
   MakeBitmaps; //Partially excessive

end;

procedure TTitleBar.MakeBitmaps;
begin

   BMCB.Width := 20;
   BMCB.Height := 20;
   BMMB.Width := 20;
   BMMB.Height := 20;
   BMSB.Width := 20;
   BMSB.Height := 20;
   BMRB.Width := 20;
   BMRB.Height := 20;
   with BMCB.Canvas do begin

      Brush.Color := btncolr;
      Rectangle(0, 0, 20, 20);
      if MD = 1 then Pen.Color := clBlack else Pen.Color := clWhite;
      MoveTo(20, 0);
      LineTo(0, 0);
      LineTo(0, 19);
      if MD = 1 then Pen.Color := clWhite else Pen.Color := clBlack;
      LineTo(19, 19);
      LineTo(19, 0);

      MoveTo( 3, 2);
      LineTo( 16, 17);
      MoveTo( 3, 17);
      LineTo( 16, 2);

   end;

   with BMMB.Canvas do begin

      Brush.Color := btncolr;
      Rectangle(0, 0, 20, 20);
      if MD = 2 then Pen.Color := clBlack else Pen.Color := clWhite;
      MoveTo(20, 0);
      LineTo(0, 0);
      LineTo(0, 19);
      if MD = 2 then Pen.Color := clWhite else Pen.Color := clBlack;
      LineTo(19, 19);
      LineTo(19, 0);

      MoveTo( 3, 2);
      LineTo( 16, 2);
      MoveTo( 3, 3);
      LineTo( 16, 3);
      MoveTo( 3, 2);
      LineTo( 3, 17);
      LineTo( 16, 17);
      LineTo( 16, 2);

   end;

   with BMSB.Canvas do begin

      Brush.Color := btncolr;
      Rectangle(0, 0, 20, 20);
     if MD = 3 then Pen.Color := clBlack else Pen.Color := clWhite;
      MoveTo(20, 0);
      LineTo(0, 0);
      LineTo(0, 19);
      if MD = 3 then Pen.Color := clWhite else Pen.Color := clBlack;
      LineTo(19, 19);
      LineTo(19, 0);

      MoveTo( 3, 16);
      LineTo( 16, 16);
      MoveTo( 3, 17);
      LineTo( 16, 17);

   end;

   with BMRB.Canvas do begin

      Brush.Color := btncolr;
      Rectangle(0, 0, 20, 20);
      if MD = 4 then Pen.Color := clBlack else Pen.Color := clWhite;
      MoveTo(20, 0);
      LineTo(0, 0);
      LineTo(0, 19);
      if MD = 4 then Pen.Color := clWhite else Pen.Color := clBlack;
      LineTo(19, 19);
      LineTo(19, 0);

      MoveTo( 3, 2);
      LineTo( 12, 2);
      LineTo( 12, 12);
      LineTo( 3, 12);
      LineTo( 3, 3);

      MoveTo( 8, 8);
      LineTo( 17, 8);
      LineTo( 17, 17);
      LineTo( 8, 17);
      LineTo( 8, 8);

   end;
// Draw the Close button
   if CloseBtn.Visible then begin
      Canvas.CopyRect(
         Rect(CloseBtn.L, CloseBtn.T, CloseBtn.L + CloseBtn.W, CloseBtn.T + CloseBtn.H),
         BMCB.Canvas, Rect(0,0,20,20) );
   end;
// Draw the Maximize button
   if MaxBtn.Visible then begin
     if IsMax = False then begin
      Canvas.CopyRect(
         Rect(MaxBtn.L, MaxBtn.T, MaxBtn.L + MaxBtn.W, MaxBtn.T + MaxBtn.H),
         BMMB.Canvas, Rect(0,0,20,20) )
     end else begin
      Canvas.CopyRect(
         Rect(MaxBtn.L, MaxBtn.T, MaxBtn.L + MaxBtn.W, MaxBtn.T + MaxBtn.H),
         BMRB.Canvas, Rect(0,0,20,20) );
     end;
   end;
// Draw the Minimize button
   if MinBtn.Visible then begin
      Canvas.CopyRect(
         Rect(MinBtn.L, MinBtn.T, MinBtn.L + MinBtn.W, MinBtn.T + MinBtn.H),
         BMSB.Canvas, Rect(0,0,20,20) );
   end;
// Refresh everything
   Canvas.Refresh;

end;

procedure TTitlebar.DrawSidewaysCanvas(X: Integer; Y: Integer);
var
   T, I: Integer;
begin

   strCaption := strCaption + ' ';
   T := Y;
   I := 1;
   repeat
      Canvas.TextOut( intLeft + (intWidth div 2) - (Canvas.TextWidth(strCaption[I]) div 2), T, strCaption[I] );
      I := I + 1;
      T := T + Canvas.TextHeight(strCaption[I]);
   until I = Length(strCaption) + 1;
   strCaption := Copy(strCaption, 1, Length(strCaption) - 1);

end;

function TTitlebar.GetTextColor(col: TColor): TColor;
var
  R,G,B: Byte;
begin

   B := (col and $FF0000) div $10000;
   G := (col and $FF00) div $100;
   R := (col and $FF);

   if R + 128 < 256 then R := R + 128 else R := R - 128;
   if G + 128 < 256 then G := G + 128 else G := G - 128;
   if B + 128 < 256 then B := B + 128 else B := B - 128;

   Result := RGB(R,G,B);
   if col = clBlack then Result := clGray;

end;

end.
